Subject: Re: bug#63754: 29.0.91; tmm breaks when tmm-completion-prompt is nil

From: Eli Zaretskii <[email-masked]>
Date: Sun, 28 May 2023 08:22:38 +0300

> From: Thiago Melo <[email-masked]>
> Date: Sat, 27 May 2023 19:48:54 +0000
> Cc: [email-masked]
> 
> On Sat, May 27, 2023 at 5:14 PM Eli Zaretskii <[email-masked]> wrote:
> > Thanks.  This was caused by a change in the completion heading line in
> > Emacs 29: it is now a customizable format string, and can be nil.  So
> > the method used by tmm.el for finding the prompt (so it could delete
> > it) is no longer workable, and must be replaced by a different method.
> >
> > Should be fixed now on the emacs-29 branch.
> 
> Cool.  I've tested, it's working nicely.  Thanks for the fix.

Thanks for testing, I'm therefore closing this bug.

> > (I also fixed it to work
> > when 'tmm-mid-prompt' is nil, something that seems to have been broken
> > since about forever -- I found that bug while testing the patch,
> > because the patch has to work also when 'tmm-mid-prompt' is nil, and
> > there are no menu shortcuts shown.)
> 
> Sorry if my comment is out of place, but I also gave a try to
> `tmm-mid-prompt' = nil.  Since it disables the tmm shortcuts, maybe it
> would be more intuitive to let users input keys and do completion at
> the minibuffer in this situation? (unless I'm missing some unwanted
> side effect here)
> 
> With this little change, for example:

I don't know.  The original completion works on the shortcuts, AFAIU,
and thus makes no sense when tmm-mid-prompt is nil.  When that
variable is nil, the user needs to use the arrow keys to select the
menu items.  If someone wants to add a completion feature to that, I
don't mind, but I don't know enough about tmm to tell, and such a
change is definitely not for the release branch.

If someone here has an opinion on this last suggestion, please speak
up.